package nc.ui.gl.mrbalancebooks;

import java.awt.CardLayout;
import java.awt.Insets;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.util.HashMap;
import java.util.Hashtable;
import javax.swing.JComponent;
import javax.swing.JFrame;
import javax.swing.JTable;
import javax.swing.ToolTipManager;
import javax.swing.table.TableCellRenderer;
import javax.swing.table.TableColumn;
import javax.swing.table.TableColumnModel;
import nc.bs.logging.Logger;
import nc.ui.bd.BDGLOrgBookAccessor;
import nc.ui.fi.printdirect.extend.IParserTreeTable;
import nc.ui.gl.IDetailView;
import nc.ui.gl.accbook.BillFormatVO;
import nc.ui.gl.accbook.CopyTwoTableUtil;
import nc.ui.gl.datacache.CurrencyDataCache;
import nc.ui.gl.datacache.GLParaDataCache;
import nc.ui.gl.mrbalancebooks.BalanceBookCellRender;
import nc.ui.gl.mrbalancebooks.BillCardTreeTableBridge;
import nc.ui.glcom.numbertool.GlCurrAmountFormat;
import nc.ui.glcom.numbertool.GlNumberFormat;
import nc.ui.ml.NCLangRes;
import nc.ui.pub.ClientEnvironment;
import nc.ui.pub.beans.MessageDialog;
import nc.ui.pub.beans.UIComboBox;
import nc.ui.pub.beans.UIPanel;
import nc.ui.pub.beans.UIRefPane;
import nc.ui.pub.beans.UITable;
import nc.ui.pub.bill.BillItem;
import nc.ui.pub.report.ReportBaseClass;
import nc.ui.pub.report.ReportItem;
import nc.ui.pub.report.treetableex.CreateTreeTableTool;
import nc.vo.bd.b54.GlorgbookVO;
import nc.vo.gl.accbook.CurrTypeConst;
import nc.vo.gl.accbook.OrientConst;
import nc.vo.gl.balancebooks.BalanceBSShowVO;
import nc.vo.gl.balancebooks.BalanceBSVO;
import nc.vo.gl.balancebooks.BalanceKeyConvertTool;
import nc.vo.glcom.balance.GlQueryVO;
import nc.vo.ml.NCLangRes4VoTransl;
import nc.vo.pub.lang.UFDouble;

public class NewBalancebookUI extends UIPanel implements MouseListener, ItemListener, IParserTreeTable {

   protected BillFormatVO format;
   private GlCurrAmountFormat amountFormat;
   private GlNumberFormat numFormat;
   private Hashtable numDigHash = new Hashtable();
   private String pk_auxCurrType = null;
   private String pk_locCurrType = null;
   private String pk_defaultCorp = null;
   BillCardTreeTableBridge bridge = null;
   private ReportBaseClass m_ReportTemplet;
   public BalanceBSShowVO[] showDatas = null;
   private IDetailView m_newbalancebookView = null;


   public NewBalancebookUI() {
      this.initialize();
   }

   public BillFormatVO getFormat() {
      if(this.format == null) {
         this.format = new BillFormatVO();
      }

      return this.format;
   }

   private void initialize() {
      try {
         if(this.getcbFormat() != null) {
            this.getcbFormat().addItem(NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000125"));
            this.getcbFormat().addItem(NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000126"));
         }

         this.getUILabelOrgNameAndCode();
      } catch (Throwable var2) {
         this.handleException(var2);
      }

      this.setLayout(new CardLayout());
      this.add(this.getReportBase(), this.getReportBase().getName());
      this.getReportBase().getBillTable().addMouseListener(this);
      this.initTable();
      CopyTwoTableUtil.getInstance().replaceCopy(this.getReportBase().getBillTable(), (UITable)null);
      if(this.getcbFormat() != null) {
         this.getcbFormat().addItemListener(this);
         this.getcbFormat().setSelectedIndex(1);
      }

   }

   public void setBackBsVOs(BalanceBSVO[] vos, JTable p_table) {
      TableColumnModel tcm = p_table.getColumnModel();
      TableColumn tm = null;
      TableCellRenderer tcr = null;

      for(int i = 0; i < tcm.getColumnCount(); ++i) {
         tm = tcm.getColumn(i);
         tcr = tm.getCellRenderer();
         if(tcr == null) {
            BalanceBookCellRender tempTcr = new BalanceBookCellRender();
            tempTcr.setVos(vos);
            tm.setCellRenderer(tempTcr);
         } else {
            ((BalanceBookCellRender)tcr).setVos(vos);
         }
      }

   }

   protected void initTable() {
   }

   public void itemStateChanged(ItemEvent e) {
      if(e.getStateChange() == 1) {
         if(this.getcbFormat().getSelectedItem().toString().trim().equals(NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000126"))) {
            this.getFormat().setNumberFormat(false);
         } else {
            this.getFormat().setNumberFormat(true);
         }

         this.resetFormat(this.getFormat());
      }

   }

   public static void main(String[] args) {
      try {
         JFrame exception = new JFrame();
         NewBalancebookUI aTricolAccbookUI = new NewBalancebookUI();
         exception.setContentPane(aTricolAccbookUI);
         exception.setSize(aTricolAccbookUI.getSize());
         exception.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
               System.exit(0);
            }
         });
         exception.show();
         Insets insets = exception.getInsets();
         exception.setSize(exception.getWidth() + insets.left + insets.right, exception.getHeight() + insets.top + insets.bottom);
         exception.setVisible(true);
      } catch (Throwable var4) {
         System.err.println("nc.ui.pub.beans.UIPanel 的 main() 中发生异常");
         var4.printStackTrace(System.out);
      }

   }

   protected void recoveTableFormat() {
      this.getReportBase().showHiddenColumn(new String[]{"glorgbookname", "bodycurrtypename", "initdebitquant", "initdebitamount", "initdebitauxamount", "initdebitlocamount", "initcreditquant", "initcreditamount", "initcreditauxamount", "initcreditlocamount", "direct", "beginbalancequantity", "beginbalanceamount", "beginfracbalanceamount", "beginlocalbalanceamount", "debitquantity", "debitamount", "fracdebitamount", "localdebitamount", "creditquantity", "creditamount", "fraccreditamount", "localcreditamount", "accumdebitquantity", "accumdebitamount", "accumfracdebitamount", "accumlocaldebitamount", "accumcreditquantity", "accumcreditamount", "accumfraccreditamount", "accumlocalcreditamount", "enddirect", "enddebitquant", "enddebitamount", "enddebitauxamount", "enddebitlocamount", "endcreditquant", "endcreditamount", "endcreditauxamount", "endcreditlocamount", "endbalancequantity", "endbalanceamount", "endfracbalanceamount", "endlocalbalanceamount"});
      if(this.bridge == null) {
         this.bridge = new BillCardTreeTableBridge(this.getReportBase(), "glorgcode", "4,./\\4,./\\3,./\\3", "glorgbookname");
      }

   }

   private void resetDataFormat(BalanceBSVO[] vos, GlQueryVO qryVO) {
      GlCurrAmountFormat format = new GlCurrAmountFormat();
      if(qryVO.getPk_currtype() != null) {
         String pk_currtype = qryVO.getPk_currtype();

         for(int i = 0; i < vos.length; ++i) {
            try {
               vos[i].setValue(26, format.formatAmount(vos[i].getValue(26) == null?null:new UFDouble(vos[i].getValue(26).toString()), pk_currtype));
               vos[i].setValue(27, format.formatAmount(vos[i].getValue(27) == null?null:new UFDouble(vos[i].getValue(27).toString()), pk_currtype));
               vos[i].setValue(28, format.formatAmount(vos[i].getValue(28) == null?null:new UFDouble(vos[i].getValue(28).toString()), pk_currtype));
               vos[i].setValue(25, format.formatAmount(vos[i].getValue(25) == null?null:new UFDouble(vos[i].getValue(25).toString()), pk_currtype));
               vos[i].setValue(18, format.formatAmount(vos[i].getValue(18) == null?null:new UFDouble(vos[i].getValue(18).toString()), pk_currtype));
               vos[i].setValue(19, format.formatAmount(vos[i].getValue(19) == null?null:new UFDouble(vos[i].getValue(19).toString()), pk_currtype));
               vos[i].setValue(20, format.formatAmount(vos[i].getValue(20) == null?null:new UFDouble(vos[i].getValue(20).toString()), pk_currtype));
               vos[i].setValue(17, format.formatAmount(vos[i].getValue(17) == null?null:new UFDouble(vos[i].getValue(17).toString()), pk_currtype));
               vos[i].setValue(22, format.formatAmount(vos[i].getValue(22) == null?null:new UFDouble(vos[i].getValue(22).toString()), pk_currtype));
               vos[i].setValue(23, format.formatAmount(vos[i].getValue(23) == null?null:new UFDouble(vos[i].getValue(23).toString()), pk_currtype));
               vos[i].setValue(24, format.formatAmount(vos[i].getValue(24) == null?null:new UFDouble(vos[i].getValue(24).toString()), pk_currtype));
               vos[i].setValue(21, format.formatAmount(vos[i].getValue(21) == null?null:new UFDouble(vos[i].getValue(21).toString()), pk_currtype));
               vos[i].setValue(14, format.formatAmount(vos[i].getValue(14) == null?null:new UFDouble(vos[i].getValue(14).toString()), pk_currtype));
               vos[i].setValue(15, format.formatAmount(vos[i].getValue(15) == null?null:new UFDouble(vos[i].getValue(15).toString()), pk_currtype));
               vos[i].setValue(16, format.formatAmount(vos[i].getValue(16) == null?null:new UFDouble(vos[i].getValue(16).toString()), pk_currtype));
               vos[i].setValue(13, format.formatAmount(vos[i].getValue(13) == null?null:new UFDouble(vos[i].getValue(13).toString()), pk_currtype));
               vos[i].setValue(14, format.formatAmount(vos[i].getValue(41) == null?null:new UFDouble(vos[i].getValue(41).toString()), pk_currtype));
               vos[i].setValue(46, format.formatAmount(vos[i].getValue(46) == null?null:new UFDouble(vos[i].getValue(46).toString()), pk_currtype));
               vos[i].setValue(44, format.formatAmount(vos[i].getValue(44) == null?null:new UFDouble(vos[i].getValue(44).toString()), pk_currtype));
               vos[i].setValue(39, format.formatAmount(vos[i].getValue(39) == null?null:new UFDouble(vos[i].getValue(39).toString()), pk_currtype));
               vos[i].setValue(14, format.formatAmount(vos[i].getValue(40) == null?null:new UFDouble(vos[i].getValue(40).toString()), pk_currtype));
               vos[i].setValue(45, format.formatAmount(vos[i].getValue(45) == null?null:new UFDouble(vos[i].getValue(45).toString()), pk_currtype));
               vos[i].setValue(42, format.formatAmount(vos[i].getValue(42) == null?null:new UFDouble(vos[i].getValue(42).toString()), pk_currtype));
               vos[i].setValue(38, format.formatAmount(vos[i].getValue(38) == null?null:new UFDouble(vos[i].getValue(38).toString()), pk_currtype));
            } catch (Exception var7) {
               var7.printStackTrace();
            }
         }
      }

   }

   private void resetFormat(BillFormatVO format) {
      boolean isTwoWayBalance = false;
      boolean isMultiCorp = format.isMultiOrg();
      boolean isMultiCurrType = format.isMultiCurrType();
      boolean isNumberFormat = format.isNumberFormat();
      boolean isLocAuxCurrType = format.isLocAuxCurrType();
      boolean isLocCurrType = format.isLocCurrType();
      boolean isAuxCurrType = format.isAuxCurrType();
      isTwoWayBalance = format.isTwoWayBalance();
      this.recoveTableFormat();
      if(!isMultiCurrType) {
         this.getReportBase().hideColumn(new String[]{"bodycurrtypename"});
      }

      if(!isTwoWayBalance) {
         this.getReportBase().hideColumn(new String[]{"initdebitquant", "initdebitamount", "initdebitauxamount", "initdebitlocamount", "initcreditquant", "initcreditamount", "initcreditauxamount", "initcreditlocamount", "enddebitquant", "enddebitamount", "enddebitauxamount", "enddebitlocamount", "endcreditquant", "endcreditamount", "endcreditauxamount", "endcreditlocamount"});
      } else {
         this.getReportBase().hideColumn(new String[]{"direct", "beginbalancequantity", "beginbalanceamount", "beginfracbalanceamount", "beginlocalbalanceamount", "enddirect", "endbalancequantity", "endbalanceamount", "endfracbalanceamount", "endlocalbalanceamount"});
      }

      if(!isNumberFormat) {
         this.getReportBase().hideColumn(new String[]{"beginbalancequantity", "debitquantity", "creditquantity", "accumdebitquantity", "accumcreditquantity", "endbalancequantity", "initdebitquant", "initcreditquant", "enddebitquant", "endcreditquant"});
      }

      if(!isLocAuxCurrType) {
         this.getReportBase().hideColumn(new String[]{"beginfracbalanceamount", "fracdebitamount", "fraccreditamount", "accumfracdebitamount", "accumfraccreditamount", "endfracbalanceamount", "initdebitauxamount", "initcreditauxamount", "enddebitauxamount", "endcreditauxamount"});
         if(isLocCurrType) {
            this.getReportBase().hideColumn(new String[]{"beginbalanceamount", "debitamount", "creditamount", "accumdebitamount", "accumcreditamount", "endbalanceamount", "initdebitamount", "initcreditamount", "enddebitamount", "endcreditamount"});
         }
      } else {
         if(isLocCurrType) {
            this.getReportBase().hideColumn(new String[]{"beginbalanceamount", "debitamount", "creditamount", "accumdebitamount", "accumcreditamount", "endbalanceamount", "beginfracbalanceamount", "fracdebitamount", "fraccreditamount", "accumfracdebitamount", "accumfraccreditamount", "endfracbalanceamount", "initdebitamount", "initcreditamount", "enddebitamount", "endcreditamount", "initdebitauxamount", "initcreditauxamount", "enddebitauxamount", "endcreditauxamount"});
         }

         if(isAuxCurrType) {
            this.getReportBase().hideColumn(new String[]{"beginbalanceamount", "debitamount", "creditamount", "accumdebitamount", "accumcreditamount", "endbalanceamount", "beginlocalbalanceamount", "localdebitamount", "localcreditamount", "accumlocaldebitamount", "accumlocalcreditamount", "endlocalbalanceamount", "initdebitamount", "initcreditamount", "enddebitamount", "endcreditamount", "initdebitlocamount", "initcreditlocamount", "enddebitlocamount", "endcreditlocamount"});
         }
      }

      if(isNumberFormat) {
         this.getcbFormat().setSelectedItem(NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000125"));
      } else {
         this.getcbFormat().setSelectedItem(NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000126"));
      }

      this.bridge.resetTableCols();
      this.getReportBase().hideColumn(new String[]{""});
      if(!format.isIsMultiyear()) {
         this.getReportBase().getBody_Item("year").setShow(false);
      } else {
         this.getReportBase().getBody_Item("year").setShow(true);
      }

   }

   protected void setTableColVisibility(int[] colsNum, boolean isVisiabled) {
   }

   public void setTableData(BalanceBSVO[] vos, GlQueryVO qryVO) {
      this.getFormat().setIsMultiyear(true);
      if(qryVO.getPk_glorgbook().length > 1 && !qryVO.isMultiCorpCombine()) {
         this.getFormat().setMultiOrg(true);
      } else {
         this.getFormat().setMultiOrg(false);
      }

      this.getFormat().setLocAuxCurrType(qryVO.isLocalFrac());
      this.getFormat().setLocCurrType(false);
      this.getFormat().setAuxCurrType(false);
      if(qryVO.getCurrTypeName().equals(CurrTypeConst.ALL_CURRTYPE)) {
         this.getFormat().setMultiCurrType(true);
      } else {
         this.getFormat().setMultiCurrType(false);
         if(qryVO.getCurrTypeName().equals(CurrTypeConst.LOC_CURRTYPE)) {
            this.getFormat().setLocCurrType(true);
         }

         if(qryVO.getCurrTypeName().equals(CurrTypeConst.AUX_CURRTYPE)) {
            this.getFormat().setAuxCurrType(true);
         }
      }

      this.getFormat().setTwoWayBalance(qryVO.getFormatVO().isTwoWayBalance());
      if(vos == null || vos.length == 0) {
         vos = new BalanceBSVO[0];
      }

      try {
         this.pk_defaultCorp = this.getPk_corp(qryVO.getBaseGlOrgBook());
         boolean showVos = qryVO.isLocalFrac();
         if(showVos) {
            this.pk_auxCurrType = GLParaDataCache.getInstance().PkFracCurr(qryVO.getBaseGlOrgBook());
         }

         this.pk_locCurrType = GLParaDataCache.getInstance().PkLocalCurr(qryVO.getBaseGlOrgBook());
      } catch (Exception var4) {
         ;
      }

      this.getlbPeriod().setText(qryVO.getYear() + "." + qryVO.getPeriod() + "-" + qryVO.getEndYear() + "." + qryVO.getEndPeriod());
      this.getlbCurrType().setText(qryVO.getCurrTypeName());
      this.getUILabelOrgNameAndCode().setText(this.getOrgNames(qryVO));
      if(!qryVO.getYear().equals(qryVO.getEndYear())) {
         this.getFormat().setIsMultiyear(true);
      } else {
         this.getFormat().setIsMultiyear(false);
      }

      BalanceBSShowVO[] showVos1 = this.formatTableData(vos);
      this.showDatas = showVos1;
      this.resetFormat(this.getFormat());
      this.bridge.setMutiCorpQ(qryVO.getPk_glorgbook().length > 1);
      this.cleanTotalRowOrgbookName(vos, qryVO, showVos1);
      this.bridge.setData(showVos1, vos);
      this.getReportBase().hideColumn(new String[]{""});
   }

   private void cleanTotalRowOrgbookName(BalanceBSVO[] vos, GlQueryVO qryVO, BalanceBSShowVO[] showVos) {
      if(qryVO.getPk_glorgbook().length > 1) {
         int i;
         String strName;
         for(i = 0; i < showVos.length; ++i) {
            strName = showVos[i].getAttributeValue("bodysubjcode").toString();
            if(strName.equals(NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000115"))) {
               showVos[i].setAttributeValue("glorgbookname", (Object)null);
            }
         }

         for(i = 0; i < vos.length; ++i) {
            try {
               strName = vos[i].getValue(0).toString();
               if(strName.equals(NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000115"))) {
                  vos[i].setValue(61, (Object)null);
               }
            } catch (Exception var7) {
               var7.printStackTrace();
            }
         }
      }

   }

   private String getOrgNames(GlQueryVO qryVO) {
      String[] strPkorgbooks = qryVO.getPk_glorgbook();
      String strorgName = "";
      GlorgbookVO[] orgbookVOs = new GlorgbookVO[strPkorgbooks.length];

      try {
         for(int ee = 0; ee < strPkorgbooks.length; ++ee) {
            orgbookVOs[ee] = BDGLOrgBookAccessor.getGlOrgBookVOByPrimaryKey(strPkorgbooks[ee]);
            strorgName = strorgName + "," + orgbookVOs[ee].getGlorgbookcode() + orgbookVOs[ee].getGlorgbookname();
         }
      } catch (Exception var6) {
         var6.printStackTrace();
      }

      strorgName = strorgName.substring(1);
      return strorgName;
   }

   public UIRefPane getlbPeriod() {
      JComponent jp = this.getReportBase().getHeadItem("period").getComponent();
      return jp != null?(UIRefPane)jp:null;
   }

   public ReportBaseClass getReportBase() {
      if(this.m_ReportTemplet == null) {
         this.m_ReportTemplet = new ReportBaseClass(false);
         this.m_ReportTemplet.setName("ReportBase");
         this.resetTemplet();
      }

      return this.m_ReportTemplet;
   }

   private void resetTemplet() {
      try {
         String ivjExc = ClientEnvironment.getInstance().getUser().getPrimaryKey();
         String pk_glorgbook = ((GlorgbookVO)ClientEnvironment.getInstance().getValue("pk_glorgbook")).m_pk_glorgbook;
         this.m_ReportTemplet.setTempletID(pk_glorgbook, "20028002", ivjExc, (String)null, (String)null, "2");
         MouseListener[] listeners = this.m_ReportTemplet.getSuperTable().getTableHeader().getMouseListeners();
         if(listeners != null && listeners.length > 0) {
            for(int i = 0; i < listeners.length; ++i) {
               if(listeners[i] instanceof ToolTipManager) {
                  this.m_ReportTemplet.getSuperTable().getTableHeader().removeMouseListener(listeners[i]);
                  break;
               }
            }
         }

         this.m_ReportTemplet.getBodyPanel().setBBodyMenuShow(false);
         this.getReportBase().getBillTable().setCellSelectionEnabled(false);
         this.getReportBase().getBillTable().setRowSelectionAllowed(true);
         this.getReportBase().getBillTable().setSelectionMode(0);
      } catch (Throwable var5) {
         this.handleException(var5);
      }

   }

   private void handleException(Throwable exception) {
      Logger.error(exception.getMessage(), exception);
      MessageDialog.showErrorDlg(this, NCLangRes4VoTransl.getNCLangRes().getStrByID("2002GL502", "UPP2002GL502-000196"), exception.getMessage());
   }

   public UIRefPane getlbCurrType() {
      JComponent jp = this.getReportBase().getHeadItem("currtypename").getComponent();
      return jp != null?(UIRefPane)jp:null;
   }

   public UIRefPane getUILabelOrgNameAndCode() {
      BillItem bit = this.getReportBase().getHeadItem("glorgbookname");
      if(bit == null) {
         return null;
      } else {
         bit.setWidth(3);
         JComponent jp = this.getReportBase().getHeadItem("glorgbookname").getComponent();
         return jp != null?(UIRefPane)jp:null;
      }
   }

   public UIComboBox getcbFormat() {
      JComponent jp = this.getReportBase().getHeadItem("booktype").getComponent();
      return jp != null?(UIComboBox)jp:null;
   }

   public int getSelectedRow() {
      return this.getReportBase().getBillTable().getSelectedRow();
   }

   private String getPk_corp(String Pk_orgbook) {
      String corp = null;

      try {
         corp = BDGLOrgBookAccessor.getPk_corp(Pk_orgbook);
      } catch (Exception var4) {
         var4.printStackTrace();
      }

      return corp;
   }

   private GlCurrAmountFormat getCurrAmountFormat() {
      if(this.amountFormat == null) {
         this.amountFormat = new GlCurrAmountFormat();
      }

      return this.amountFormat;
   }

   private GlNumberFormat getNumFormat() {
      if(this.numFormat == null) {
         this.numFormat = new GlNumberFormat();
      }

      return this.numFormat;
   }

   private int getNumDigit(BalanceBSVO vo) {
      String pk_corp = null;

      try {
         String e = (String)vo.getValue(59);
         pk_corp = this.getPk_corp(e);
         if(vo != null && !this.numDigHash.containsKey(pk_corp)) {
            Integer digit = null;
            if(pk_corp != null && !pk_corp.trim().equals("")) {
               digit = GLParaDataCache.getInstance().getQuantityDigit(pk_corp);
            }

            if(digit == null) {
               if(!this.numDigHash.containsKey(this.pk_defaultCorp)) {
                  digit = GLParaDataCache.getInstance().getQuantityDigit(this.pk_defaultCorp);
                  this.numDigHash.put(this.pk_defaultCorp, digit);
               }

               return ((Integer)this.numDigHash.get(this.pk_defaultCorp)).intValue();
            }

            this.numDigHash.put(pk_corp, digit);
            return digit.intValue();
         }
      } catch (Exception var5) {
         var5.printStackTrace();
      }

      return pk_corp != null && !pk_corp.trim().equals("")?((Integer)this.numDigHash.get(pk_corp)).intValue():2;
   }

   private Object getValueAfterDigit(BalanceBSVO vo, int key) {
      Object objtemp = null;
      int digit = 2;

      try {
         objtemp = vo.getValue(key);
         switch(key) {
         case 5:
         case 9:
         case 13:
         case 17:
         case 21:
         case 25:
         case 29:
         case 33:
         case 38:
         case 39:
            if(objtemp == null) {
               objtemp = new UFDouble(0);
            } else {
               objtemp = ((UFDouble)objtemp).setScale(this.getNumDigit(vo), 4);
            }
            break;
         case 6:
         case 10:
         case 14:
         case 18:
         case 22:
         case 26:
         case 30:
         case 34:
         case 40:
         case 41:
            Object e = vo.getValue(4);
            if(objtemp == null) {
               objtemp = new UFDouble(0);
            } else if(e != null && !e.toString().equals("") && !e.toString().equals("ZZZZZZZZZZZZZZZZZZZZ")) {
               digit = CurrencyDataCache.getInstance().getCurrtypeBypk(e.toString()).getCurrdigit().intValue();
               objtemp = ((UFDouble)objtemp).setScale(digit, 4);
            } else {
               digit = CurrencyDataCache.getInstance().getCurrtypeBypk(this.pk_locCurrType).getCurrdigit().intValue();
               objtemp = ((UFDouble)objtemp).setScale(digit, 4);
            }
            break;
         case 7:
         case 11:
         case 15:
         case 19:
         case 23:
         case 27:
         case 31:
         case 35:
         case 45:
         case 46:
            if(this.pk_auxCurrType != null) {
               digit = CurrencyDataCache.getInstance().getCurrtypeBypk(this.pk_auxCurrType).getCurrdigit().intValue();
            }

            if(objtemp == null) {
               objtemp = new UFDouble(0);
            } else {
               objtemp = ((UFDouble)objtemp).setScale(digit, 4);
            }
            break;
         case 8:
         case 12:
         case 16:
         case 20:
         case 24:
         case 28:
         case 32:
         case 36:
         case 42:
         case 44:
            if(objtemp != null) {
               digit = CurrencyDataCache.getInstance().getCurrtypeBypk(this.pk_locCurrType).getCurrdigit().intValue();
               objtemp = ((UFDouble)objtemp).setScale(digit, 4);
            }
         case 37:
         case 43:
         }

         return objtemp;
      } catch (Exception var6) {
         Logger.error("精度控制时出现错误", var6);
         return null;
      }
   }

   private BalanceBSShowVO[] formatTableData(BalanceBSVO[] vos) {
      if(vos != null && vos.length != 0) {
         BalanceBSShowVO[] showVos = new BalanceBSShowVO[vos.length];
         ReportItem[] items = this.getReportBase().getBody_Items();

         for(int row = 0; row < vos.length; ++row) {
            showVos[row] = new BalanceBSShowVO();

            int ee;
            for(ee = 0; ee < items.length; ++ee) {
               String subjCodeInnerCodeMap = items[ee].getKey();
               Object k = null;

               try {
                  int strSubjCode = BalanceKeyConvertTool.getIntKey(subjCodeInnerCodeMap);
                  k = this.getValueAfterDigit(vos[row], strSubjCode);
                  if(subjCodeInnerCodeMap.equals("direct") || subjCodeInnerCodeMap.equals("enddirect")) {
                     Integer iTemp = (Integer)k;
                     if(iTemp.intValue() == 1) {
                        k = OrientConst.DEBIT;
                     } else if(iTemp.intValue() == 2) {
                        k = OrientConst.CREDIT;
                     } else {
                        k = OrientConst.ZERO;
                     }
                  }
               } catch (Exception var10) {
                  this.handleException(var10);
               }

               showVos[row].setAttributeValue(subjCodeInnerCodeMap, k);
            }

            try {
               ee = 1;
               HashMap var12 = new HashMap();

               for(int var14 = 0; var14 < vos.length; ++var14) {
                  String var13 = null;
                  if(!this.getFormat().isIsMultiyear()) {
                     var13 = vos[var14].getValue(0).toString();
                  } else {
                     var13 = vos[var14].getValue(0).toString() + vos[var14].getValue(64).toString();
                  }

                  if(var12.get(var13) == null) {
                     var12.put(var13, (new Integer(1000 + ee)).toString());
                     ++ee;
                  }
               }

               if(!this.getFormat().isIsMultiyear()) {
                  showVos[row].setAttributeValue("glorgcode", var12.get(vos[row].getValue(0).toString()).toString() + vos[row].getValue(60));
               } else {
                  showVos[row].setAttributeValue("glorgcode", var12.get(vos[row].getValue(0).toString() + vos[row].getValue(64).toString()).toString() + vos[row].getValue(60));
               }
            } catch (Exception var11) {
               this.handleException(var11);
            }
         }

         return showVos;
      } else {
         return null;
      }
   }

   public BillCardTreeTableBridge getBridge() {
      return this.bridge;
   }

   public void setBridge(BillCardTreeTableBridge bridge) {
      this.bridge = bridge;
   }

   public BalanceBSShowVO[] getShowDatas() {
      return this.showDatas;
   }

   public CreateTreeTableTool getTreeTableTool() {
      return this.getBridge().getCttt();
   }

   public void addNewbalancebookViewListener(IDetailView newbalancebookView) {
      this.m_newbalancebookView = newbalancebookView;
   }

   public void mouseClicked(MouseEvent paramMouseEvent) {
      if(paramMouseEvent.getSource() == this.getReportBase().getBillTable() && paramMouseEvent.getClickCount() == 2) {
         this.m_newbalancebookView.openDetails();
      }

   }

   public void mousePressed(MouseEvent paramMouseEvent) {
   }

   public void mouseReleased(MouseEvent paramMouseEvent) {
   }

   public void mouseEntered(MouseEvent paramMouseEvent) {
   }

   public void mouseExited(MouseEvent paramMouseEvent) {
   }
}
